package app2.client;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.util.Hashtable;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import generated.client.CustomTypes;

/**
 * This class is MIDP client.
 */

public class ClientApplicationMidp extends MIDlet {

    private static String url = "http://localhost:8080/project/servlet/";
    static protected HttpConnection connection = null;
	static private DataOutputStream dos = null;
	static private DataInputStream dis = null;
    
    protected void startApp() throws MIDletStateChangeException {
    	loadData();
    	
		Hashtable h = new Hashtable();
		for (short i = 0; i < 6; i++) {
			Hashtable nh = new Hashtable();
			nh.put("type", "InventoryObject");
			nh.put("idinv", new Short(i));
			nh.put("valueinv", new Short(i));
			h.put("" + i, nh);
		}
		uploadData(h);    	
    }
    
    /**
     * Load data from the database  retrieved into a Hashtable.
     * @param applicationID
     * @param username
     */
    protected void loadData() {
    	String formData ="type=select";
		System.out.println(formData);
		
    	try {
			System.out.println("\ncall list servlet");
	        connection = (HttpConnection) Connector.open(
	        		url+"InventoryObjectServlet",
					Connector.READ_WRITE,
					true);
	        System.out.println("servlet request " + url+"InventoryObjectServlet" + " connection "+connection);
	        connection.setRequestMethod(HttpConnection.POST);
	        connection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
	        connection.setRequestProperty("User-Agent", "Profile/MIDP-2.0 Configuration/CLDC-1.0");
	        connection.setRequestProperty("Content-Language", "fr");
	        connection.setRequestProperty("Accept", "application/octet-stream");
	        
	        byte[] data = formData.getBytes();
	        connection.setRequestProperty("Content-Length", Integer.toString(data.length));
	        
	        dos = connection.openDataOutputStream();
	        dos.write(data);
	        dos.close();
	        
	        if (connection.getResponseCode() == HttpConnection.HTTP_OK) {
			    dis = connection.openDataInputStream();
				System.out.println(dis);
				if (dis != null) {
					Hashtable h = CustomTypes.decodeData(dis);
					System.out.println("\nh = "+h);
					// Here, you can treat the data
				}
	        }
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
	}    
    
    /**
     * Update the given Hashtable into the database.
     * @param applicationID
     * @param username
     * @param h
     * @return
     */
    protected Hashtable uploadData(Hashtable h) {
    	String formData ="type=update";
		System.out.println(formData);
		
    	try {
			System.out.println("\ncall update servlet");
	        connection = (HttpConnection) Connector.open(
					url+"InventoryObjectServlet",
					Connector.READ_WRITE,
					true);
	        connection.setRequestMethod(HttpConnection.POST);
	        connection.setRequestProperty("Content-Type", "application/octet-stream");
	        
	        byte[] data = formData.getBytes();
	        connection.setRequestProperty("Content-Length", Integer.toString(data.length));
	        
	        dos = connection.openDataOutputStream();
	        try {
	        	CustomTypes.encodeData(h,dos);
	        	System.out.println("Encoding hashtable: "+h);
	        } catch (Throwable t) {
	        	t.getMessage();
	        	t.printStackTrace();
	        }
	        dos.close();
	        
	        if (connection.getResponseCode() == HttpConnection.HTTP_OK){
			    dis = connection.openDataInputStream();
				System.out.println(dis);
				if (dis != null) {
					System.out.println("\nh = "+h);
					return h;
				}
	        }
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
		return new Hashtable();
	}
    
    protected void pauseApp() {}

    protected void destroyApp(boolean arg0) throws MIDletStateChangeException {}

}
