/** 
 * MooDS Encoder/Decoder for Flash.
 * Encoding version: 1200
 * @author Generated by MooDS Generator v2.1.0 - 2006 CNAM, INT, Filao 
 */

package generated.client;

import generated.*;
import java.util.Hashtable;
import java.io.DataOutputStream;
import java.io.DataInputStream;

//This class has been generated by MooDS Generator to handle objects
// for binarisation input/output.
public class CustomTypes {

	// types
	public final static byte TYPE_NEWPLAYER = 1;
	public final static byte TYPE_UPDATEPLAYER = 2;
	public final static byte TYPE_PINGPLAYER = 3;


	// encodeData root method
	public static void encodeData(Hashtable h,DataOutputStream dos) throws Exception {
		dos.writeShort(1200);
		dos.writeShort(h.size());
		int nbSend = h.size();
		for(int i=0; i <nbSend; i++){
			Object o = h.get(""+i);
			if (o instanceof NewPlayer) {
				dos.writeByte(TYPE_NEWPLAYER);
				encodeNewPlayer(dos,((NewPlayer) o));
			}
			if (o instanceof UpdatePlayer) {
				dos.writeByte(TYPE_UPDATEPLAYER);
				encodeUpdatePlayer(dos,((UpdatePlayer) o));
			}
			if (o instanceof PingPlayer) {
				dos.writeByte(TYPE_PINGPLAYER);
				encodePingPlayer(dos,((PingPlayer) o));
			}
		}
	}


	// decodeData rooy method
	public static Hashtable decodeData(DataInputStream dis) throws Exception {
		dis.readShort();
		Hashtable h = new Hashtable();
		short nb = dis.readShort();
		int nbObj = nb;
		while (nb != 0) {
			String key = ""+(nbObj - nb);
			byte type = dis.readByte();
			if (type == 1) {
				NewPlayer customType = decodeNewPlayer(dis);
				h.put(key,customType);
			}
			if (type == 2) {
				UpdatePlayer customType = decodeUpdatePlayer(dis);
				h.put(key,customType);
			}
			if (type == 3) {
				PingPlayer customType = decodePingPlayer(dis);
				h.put(key,customType);
			}
			nb--;
		}
		return h;
	}


	// encoding method for each custom type
	private static void encodeNewPlayer(DataOutputStream dos,NewPlayer customType) throws Exception {
		dos.writeShort(customType.getId());
		dos.writeInt(customType.getX());
		dos.writeInt(customType.getY());
		dos.writeUTF(customType.getUsername());
	}


	private static void encodeUpdatePlayer(DataOutputStream dos,UpdatePlayer customType) throws Exception {
		multicastRecipientsEncoding(dos,customType.getRecipients());
		dos.writeShort(customType.getId());
		dos.writeInt(customType.getX());
		dos.writeInt(customType.getY());
		dos.writeInt(customType.getSpeedx());
		dos.writeInt(customType.getSpeedy());
	}


	private static void encodePingPlayer(DataOutputStream dos,PingPlayer customType) throws Exception {
		dos.writeShort(customType.getId());
	}



	// decoding method for each custom type
	public static NewPlayer decodeNewPlayer(DataInputStream dis) throws Exception {
		NewPlayer customType = new NewPlayer();

		customType.setId(dis.readShort());
		customType.setX(dis.readInt());
		customType.setY(dis.readInt());
		customType.setUsername(dis.readUTF());
		return customType;
	}


	public static UpdatePlayer decodeUpdatePlayer(DataInputStream dis) throws Exception {
		short[] recipients = multicastRecipientsDecoding(dis);;
		UpdatePlayer customType = new UpdatePlayer(recipients);

		customType.setId(dis.readShort());
		customType.setX(dis.readInt());
		customType.setY(dis.readInt());
		customType.setSpeedx(dis.readInt());
		customType.setSpeedy(dis.readInt());
		return customType;
	}


	public static PingPlayer decodePingPlayer(DataInputStream dis) throws Exception {
		PingPlayer customType = new PingPlayer();

		customType.setId(dis.readShort());
		return customType;
	}



	// multicast communication methods
	private static void multicastRecipientsEncoding(DataOutputStream dos,short[] recipients) throws Exception {
		dos.writeByte((byte) recipients.length);
		for(int i=0; i <recipients.length; i++){
			dos.writeShort(recipients[i]);
		}
	}

	private static short[] multicastRecipientsDecoding(DataInputStream dis) throws Exception {
		short[] recipients = new short[dis.readByte()];
		for(int i=0; i <recipients.length; i++){
			recipients[i] = dis.readShort();
		}
		return recipients;
	}

}
